/* Water detection
 * 
 * Created by D.Gass
 * 
 * Email: dan01@mail.info-suivi.top
 * 
 * November 2023
 * 
 *  use of Github: https://github.com/mobizt/ESP-Mail-Client
*/
ADC_MODE(ADC_VCC);
// Include WiFi library
#include <ESP8266WiFi.h>
// define Wifi values
#define WIFI_SSID "XXXXXXX"
#define WIFI_PASSWORD "XXXXXXXX"
// smtp def ==================================
#include <ESP_Mail_Client.h>
#define SMTP_HOST "XXXXXXXX"
#define SMTP_PORT esp_mail_smtp_port_25
#define AUTHOR_EMAIL "XXXXXXXXXX"            // sender email
#define AUTHOR_PASSWORD "XXXXXXX"                // sender pwd
String receiver = "XXXXXXXXX";            // receiver email
String messageid = "Message-ID: <Water-probe>";  // sender msg ID
/* The SMTP Session object used for Email sending */
SMTPSession smtp;
/* Callback function to get the Email sending status */
void smtpCallback(SMTP_Status status);
int gmtoffset = 1;                                    // time zone
// my infos to send ==========================
String subject = "Water probe informations"; 
String htmlMsg ;  // this string is build by the programm
// Define water and battery detection variables
const int onboardled = 2;  
const int waterinput = 5; // water indicator pin
int hourcounter = 0;  // counter increased each reset and stored in non volatile memory
float voltage = 0; // VCC voltage measured
const int voltagemin = 3;  // min VCC limit
const int hourcountermax = 24; // limit reached send an alive info  <==  ex one day = 24
int waterind ;  // water status : 1 = OK, 2 = Water detection
#define MSG_BUFFER_SIZE  (50)
char msg[MSG_BUFFER_SIZE];
String trv = " ";
String debmsgr = "<p> <span style=\"color:#ff0000;\">==== ";
String debmsgb = "<p> <span style=\"color:#2596BE;\">==== ";
String endmsg = " ====</span></p>";
float lp = 0;
// SETUP
void setup() {
  pinMode(onboardled,OUTPUT);
  pinMode(waterinput,INPUT);  
  Serial.begin(74880);  // default esp8266 speed to become feedback when esp8266 starts/wakes up
  Serial.println(" PROGRAMM STARTS ==========================================================");
  delay(1000); // time for signals to raise
  waterind = digitalRead(waterinput);
  waterind = waterind + 1; 
  hourcounter = ReadCounter();
  if (hourcounter < 0) {hourcounter = 0; WriteCounter(hourcounter); }
    hourcounter++;
    digitalWrite(onboardled,LOW);
    // read VCC
    uint16_t v = ESP.getVcc();
    float_t voltage = ((float)v/1024.0f) - 0.09;  // -0.09V to adjust measured VCC with extrnal voltmeter
    // test if water is detected  or battery low or one day passed
    if ((waterind == 2)  || (voltage < voltagemin) || hourcounter > hourcountermax)
      {
      // send values
      if (waterind == 2) trv = debmsgr + "Water alarm !!" + endmsg;
         else trv = debmsgb + "No Water alarm" + endmsg;;
       if (voltage < voltagemin) trv = trv + debmsgr +"Current voltage low : " + String(voltage,2) + "V"+ endmsg;
         else trv = trv + debmsgb +"Current voltage OK : " + String(voltage,2) + "V"+ endmsg;
      if (hourcounter > hourcountermax) trv = trv + debmsgb + "Normal alive test" + endmsg;
      htmlMsg =  trv + "<p>The message was sent via ESP12 Water probe.</p>";
      smtpsendmail();
      if (hourcounter > hourcountermax) hourcounter = 1;
      delay(50);
      WiFi.disconnect(); // disconnect wifi
      delay(2000); // time to achieve 
      }      
    WriteCounter(hourcounter); // write hourcounter to non volatile memory
    delay(1000);
    Serial.println(" PROGRAMM GOES SLEEP =========================================================="); 
    ESP.deepSleep(3633e6,RF_NO_CAL);
    //ESP.deepSleep(180e6,RF_NO_CAL); // for testing
}
void loop(){}